<?php
App::uses('BuzzWaiversComponent', 'BuzzWaivers.Controller/Component');

class BookingCheckComponent extends BuzzWaiversComponent {

	public $_controller = null;

	public function check($data) {

		$bookingRefs = array_keys($data);

		$Participant = ClassRegistry::init('BuzzWaivers.Participant');

		$participants = $Participant->find('all', array(
			'conditions' => array(
				'sales_ref' => $bookingRefs
			)
		));

		$waiverCount = array();
		$participantIds = array();

		if (! empty($participants)) {
			foreach($participants as $participantKey => $participant) {
				$salesRef = $participant['Participant']['sales_ref'];
				if ($participant['Participant']['waiver_complete'] == '1') {
					if (! empty($waiverCount[$salesRef])) {
						$waiverCount[$salesRef] = $waiverCount[$salesRef] + 1;
					} else {
						$waiverCount[$salesRef] = 1;
					}

					if (! empty($waiverCount[$salesRef]) && $waiverCount[$salesRef] >= count($data[$salesRef])) {
						// All waivers complete
						foreach ($data[$salesRef] as $key => $item) {
							if (! empty($data[$salesRef][$key]['signed_waivers'])) {
								$data[$salesRef][$key]['signed_waivers']++;
							} else {
								$data[$salesRef][$key]['signed_waivers'] = 1;
							}


						}
					}
				}

				$participantIds[$salesRef] = $participant['Participant']['id'];
			}
		}

		foreach ($data as $salesRef => $items) {
			if (! empty($items)) {
				foreach ($items as $key => $item) {
					if (! empty($item['signed_waivers']) && $item['signed_waivers'] == $item['participants']) {
						$data[$salesRef][$key]['message'] = ' <i class="fa fa-check"></i> ' . __d('buzz_waivers', 'All Waivers Signed');
						$data[$salesRef][$key]['waiverCompleted'] = true;
					}
				}
			}
		}

		$this->_controller->set('participants', $participantIds);
		$this->_controller->set('showWaivers', true);

		return $data;

	}

}
